%define major   0
%define libname %mklibname efence %{major}
%define devname %mklibname efence -d

Summary:	A debugger which detects memory allocation violations
Name:		ElectricFence
Version:	2.2.2
Release:	14
License:	GPLv2
Group:		Development/Other
URL:		http://perens.com/FreeSoftware/ElectricFence/
# ftp://ftp.perens.com/pub/ElectricFence/beta/ used to be here, but
# the site is inaccessible as of lately.  I looked through the web but
# didn't find anything.  Debian has a link to a site that hosts an
# obsolete version.  I don't think there's any proper upstream for
# this.
Source:		%{name}-%{version}.tar.gz
Patch1:		ElectricFence-2.0.5-longjmp.patch
Patch2:		ElectricFence-2.1-vaarg.patch
Patch3:		ElectricFence-2.2.2-pthread.patch
Patch4:		ElectricFence-2.2.2-madvise.patch
Patch5:		ElectricFence-mmap-size.patch
Patch6:		ElectricFence-2.2.2-banner.patch
Patch7:		ElectricFence-2.2.2-ef.patch
Patch8:		ElectricFence-2.2.2-builtins.patch
Patch9:		ElectricFence-2.2.2-sse.patch
Patch10:	ElectricFence-2.2.2-posix_memalign.patch
Patch11:	ElectricFence-2.2.2-malloc_usable_size.patch
Patch12:	ElectricFence-2.2.2-man-ef.patch

%description
ElectricFence is a utility for C programming and
debugging. ElectricFence uses the virtual memory hardware of your
system to detect when software overruns malloc() buffer boundaries,
and/or to detect any accesses of memory released by
free(). ElectricFence will then stop the program on the first
instruction that caused a bounds violation and you can use your
favorite debugger to display the offending statement.

Install ElectricFence if you need a debugger to find malloc()
violations.

%package -n %{libname}
Summary:	Shared Libraries for Electric Fence
Group:		System/Libraries

%description -n %{libname}
This package contains Electric Fence shared object library. Electric
Fence is a debugger which detects memory allocation violations.

%package -n %{devname}
Summary:	Static library for Electric Fence
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	efence-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{libname}-devel < 2.2.2-13

%description -n %{devname}
This package contains the static library for Electric Fence.

%prep
%setup -q
%patch1 -p1 -b .longjmp
%patch2 -p1 -b .vaarg
%patch3 -p1 -b .pthread
%patch4 -p1 -b .madvise
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1

%build
make CFLAGS='%{optflags} -DUSE_SEMAPHORE -fpic'

%install
mkdir -p %{buildroot}{%{_bindir},%{_libdir},%{_mandir}/man{1,3}}

make	BIN_INSTALL_DIR=%{buildroot}%{_bindir} \
	LIB_INSTALL_DIR=%{buildroot}%{_libdir} \
	MAN_INSTALL_DIR=%{buildroot}%{_mandir} \
	install

echo ".so man3/efence.3" > %{buildroot}%{_mandir}/man3/libefence.3

%files
%doc README COPYING
%{_mandir}/man1/ef.1*
%{_mandir}/man3/efence.3*
%{_mandir}/man3/libefence.3*
%{_bindir}/ef

%files -n %{libname}
%{_libdir}/*.so.*

%files -n %{devname}
%{_libdir}/*.a
%{_libdir}/*.so

%changelog
* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 2.2.2-14
+ Revision: 1ff2dfa
- MassBuild#440: Increase release tag


